// I[vAhX@ɂnbV

public class OpenHash<K,V> {

	//--- oPbg̏ ---//
	enum Status {OCCUPIED, EMPTY, DELETED};	// {f[^i[, , 폜}

	//--- oPbg ---//
	static class Bucket<K,V> {
		private K key;					// L[l
		private V data;					// f[^
		private Status stat;		// 

		//--- RXgN^ ---//
		Bucket() {
			stat = Status.EMPTY;	// oPbg͋
		}

		//--- StB[hɒlݒ ---//
		void set(K key, V data, Status stat) {
			this.key  = key;			// L[l
			this.data = data;			// f[^
			this.stat = stat;			// 
		}

		//--- Ԃݒ ---//
		void setStat(Status stat) {
			this.stat = stat;
		}

		//--- L[lԂ ---//
		K getKey() {
			return key;
		}

		//--- f[^Ԃ ---//
		V getValue() {
			return data;
		}

		//--- L[̃nbVlԂ ---//
		public int hashCode() {
			return key.hashCode();
		}
	}

	private int size;								// nbV\̑傫
	private Bucket<K,V>[] table;		// nbV\

	//--- RXgN^ ---//
	public OpenHash(int size) {
		try {
			table = new Bucket[size];
			for (int i = 0; i < size; i++)
				table[i] = new Bucket<K,V>();
			this.size = size;
		} catch (OutOfMemoryError e) {		// \𐶐łȂ
			this.size = 0;
		}
	}

	//--- nbVl߂ ---//
	public int hashValue(Object key) {
		return key.hashCode() % size;
	}

	//--- ănbVl߂ ---//
	public int rehashValue(int hash) {
		return (hash + 1) % size;
	}

	//--- L[lkeỹoPbg̒T ---//
	private Bucket<K,V> searchNode(K key) {
		int hash = hashValue(key);			// Tf[^̃nbVl
		Bucket<K,V> p = table[hash];		// ڃoPbg

		for (int i = 0; p.stat != Status.EMPTY && i < size; i++) {
			if (p.stat == Status.OCCUPIED && p.getKey().equals(key))
				return p;
			hash = rehashValue(hash);			// ănbV
			p = table[hash];
		}
		return null;
	}

	//--- L[lkey̗vf̒Tif[^ԋpj---//
	public V search(K key) {
		Bucket<K,V> p = searchNode(key);
		if (p != null)
			return p.getValue();
		else
			return null;
	}

	//--- L[lkeyŃf[^data̗vf̒ǉ ---//
	public int add(K key, V data) {
		if (search(key) != null)
			return 1;							// ̃L[l͓o^

		int hash = hashValue(key);			// ǉf[^̃nbVl
		Bucket<K,V> p = table[hash];		// ڃoPbg
		for (int i = 0; i < size; i++) {
			if (p.stat == Status.EMPTY || p.stat == Status.DELETED) {
				p.set(key, data, Status.OCCUPIED);
				return 0;
			}
			hash = rehashValue(hash);			// ănbV
			p = table[hash];
		}
		return 2;												// nbV\t
	}

	//--- L[lkey̗vf̍폜 ---//
	public int remove(K key) {
		Bucket<K,V> p = searchNode(key);	// ڃoPbg
		if (p == null)
			return 1;												// ̃L[l͓o^ĂȂ

		p.setStat(Status.DELETED);
		return 0;
	}

	//--- nbV\_v ---//
	public void dump() {
		for (int i = 0; i < size; i++) {
			System.out.printf("%02d ", i);
			switch (table[i].stat) {
			 case OCCUPIED : 
				System.out.printf("%s (%s)\n", 
										table[i].getKey(), table[i].getValue());
				break;

			 case EMPTY :
			 	System.out.println("-- o^ --");	break;

			 case DELETED :
			 	System.out.println("-- 폜 --");	break;
			}
		}
	}
}
