// K4-5
// int^Œ蒷L[i\bhsearchǉj

public class IntQueue {
	private int[] que;			// L[p̔z
	private int capacity;		// L[̗e
	private int front;			// 擪vfJ[\
	private int rear;				// vfJ[\
	private int num;				// ݂̃f[^

	//--- sOFL[ ---//
	public class EmptyIntQueueException extends RuntimeException {
		public EmptyIntQueueException() { }
	}

	//--- sOFL[t ---//
	public class OverflowIntQueueException extends RuntimeException {
		public OverflowIntQueueException() { }
	}

	//--- RXgN^ ---//
	public IntQueue(int maxlen) {
		num = front = rear = 0;
		capacity = maxlen;
		try {
			que = new int[capacity];				// L[{̗p̔z𐶐
		} catch (OutOfMemoryError e) {		// łȂ
			capacity = 0;
		}
	}

	//--- L[Ƀf[^GL[ ---//
	public int enque(int x) throws OverflowIntQueueException {
		if (num >= capacity)
			throw new OverflowIntQueueException();			// L[͖t
		que[rear++] = x;
		num++;
		if (rear == capacity)
			rear = 0;
		return x;
	}

	//--- L[f[^fL[ ---//
	public int deque() throws EmptyIntQueueException {
		if (num <= 0)
			throw new EmptyIntQueueException();			// L[͋
		int x = que[front++];
		num--;
		if (front == capacity)
			front = 0;
		return x;
	}

	//--- L[f[^s[Ni擪f[^`j ---//
	public int peek() throws EmptyIntQueueException {
		if (num <= 0)
			throw new EmptyIntQueueException();			// L[͋
		return que[front];
	}

	//--- L[ɂ ---//
	public void clear() {
		num = front = rear = 0;
	}

	//--- L[xTăCfbNXiȂ-1jԂ ---//
	public int indexOf(int x) {
		for (int i = 0; i < num; i++) {
			int idx = (i + front) % capacity;
			if (que[idx] == x)				// T
				return idx;
		}
		return -1;									// Ts
	}

	//--- L[xTĐ擪牽ԖڂiȂ0jԂ ---//
	public int search(int x) {
		for (int i = 0; i < num; i++)
			if (que[(i + front) % capacity]  == x)	// T
				return i + 1;
		return 0;																	// Ts
	}

	//--- L[̗eʂԂ ---//
	public int getCapacity() {
		return capacity;
	}

	//--- L[ɒ~Ăf[^Ԃ ---//
	public int size() {
		return num;
	}

	//--- L[͋ł邩 ---//
	public boolean isEmpty() {
		return num <= 0;
	}

	//--- L[͖tł邩 ---//
	public boolean isFull() {
		return num >= capacity;
	}

	//--- L[̑Sf[^擪̏ɕ\ ---//
	public void dump() {
		if (num <= 0)
			System.out.println("L[͋łB");
		else {
			for (int i = 0; i < num; i++)
				System.out.print(que[(i + front) % capacity] + " ");
			System.out.println();
		}
	}
}
