// K9-1{K9-2
// QT

import java.util.Comparator;

public class BinTree<K,V> {

	//--- m[h ---//
	static class Node<K,V> {
		private K key;						// L[l
		private V data;						// f[^
		private Node<K,V> left;		// |C^iqm[hւ̎QƁj
		private Node<K,V> right;	// E|C^iEqm[hւ̎QƁj

		//--- RXgN^ ---//
		Node(K key, V data, Node<K,V> left, Node<K,V> right) {
			this.key   = key;
			this.data  = data;
			this.left  = left;
			this.right = right;
		}

		//--- L[lԂ ---//
		K getKey() {
			return key;
		}

		//--- f[^Ԃ ---//
		V getValue() {
			return data;
		}

		//--- f[^̕\ ---//
		void print() {
			System.out.println(data);
		}
	}

	private Node<K,V> root;														// 
	private Comparator<? super K> comparator = null;	// Rp[^

	//--- RXgN^ ---//
	public BinTree() {
		root = null;
	}

	//--- RXgN^ ---//
	public BinTree(Comparator<? super K> c) {
		this();
		comparator = c;
	}

	//--- ̃L[lr ---//
	private int comp(K key1, K key2) {
		return (comparator == null) ? ((Comparable<K>)key1).compareTo(key2)
																: comparator.compare(key1, key2);
	}

	//--- L[ɂT ---//
	public V search(K key)	{
		Node<K,V> p = root;									// ɒ

		while (true) {
			if (p == null)										// ȏi߂Ȃ
				return null;										// cTs
			int cond = comp(key, p.getKey());	// keyƃm[hp̃L[r
			if (cond == 0)										// 
				return p.getValue();						// cT
			else if (cond < 0)								// keŷق
				p = p.left;											// c؂T
			else															// keŷق傫
				p = p.right;										// cE؂T
		}
	}

	//--- nodeƂ镔؂Ƀm[h<K,V>} ---//
	private void addNode(Node<K,V> node, K key, V data) {
		int cond = comp(key, node.getKey());
		if (cond == 0)
			return;							// key͂QT؏Ɋɑ
		else if (cond < 0) {
			if (node.left == null)
				node.left = new Node<K,V>(key, data, null, null);
			else
				addNode(node.left, key, data);			// ؂ɒ
		} else {
			if (node.right == null)
				node.right = new Node<K,V>(key, data, null, null);
			else
				addNode(node.right, key, data);			// E؂ɒ
		}
	}

	//--- m[h} ---//
	public void add(K key, V data) {
		if (root == null)
			root = new Node<K,V>(key, data, null, null);
		else
			addNode(root, key, data);
	}

	//--- L[lkeỹm[h폜 --//
	public boolean remove(K key) {
		Node<K,V> p = root;							// ̃m[h
		Node<K,V> parent = null;				// ̃m[h̐em[h
		boolean isLeftChild = true;			// pparent̍qm[hH

		while (true) {
			if (p == null)											// ȏi߂Ȃ
				return false;											// c̃L[l݂͑Ȃ
			int cond = comp(key, p.getKey());		// keyƃm[hp̃L[lr
			if (cond == 0)											// 
				break;														// cT
			else {
				parent = p;												// }Oɐeݒ
				if (cond < 0) {										// keŷق
					isLeftChild = true;							// cꂩ炭͍̂̎q
					p = p.left;											// c؂T
				} else {													// keŷق傫
					isLeftChild = false;						// cꂩ炭͉̂E̎q
					p = p.right;										// cE؂T
				}
			}
		}

		if (p.left == null) {									// pɂ͍̎qȂc
			if (p == root)					 
				root = p.right;
			else if (isLeftChild)
				parent.left  = p.right;					// e̍|C^E̎qw
			else
				parent.right = p.right;					// ẻE|C^E̎qw
		} else if (p.right == null) {				// pɂ͉E̎qȂc
			if (p == root)
				root = p.left;
			else if (isLeftChild)
				parent.left  = p.left;					// e̍|C^̎qw
			else
				parent.right = p.left;					// ẻE|C^̎qw
		} else {
			parent = p;
			Node<K,V> left = p.left;					// ؂̒̍őm[h
			isLeftChild = true;
			while (left.right != null) {			// őm[hleftT
				parent = left;
				left = left.right;
				isLeftChild = false;
			}
			p.key  = left.key;								// left̃L[lpɈړ
			p.data = left.data;								// left̃f[^pɈړ
			if (isLeftChild)
				parent.left  = left.left;				// left폜
			else
				parent.right = left.left;				// left폜
		}
		return true;
	}

	//--- nodeƂ镔؂̃m[hL[l̏ɕ\ ---//
	private void printSubTree(Node node) {
		if (node != null) {
			printSubTree(node.left);							// ؂L[l̏ɕ\
			System.out.println(node.key + " " + node.data);			// node\
			printSubTree(node.right);							// E؂L[l̏ɕ\
		}
	}

	//--- Sm[hL[l̏ɕ\ ---//
	public void print() {
		printSubTree(root);
	}

	//--- nodeƂ镔؂̃m[hL[l̍~ɕ\ ---//
	private void printSubTreeR(Node node) {
		if (node != null) {
			printSubTreeR(node.right);						// E؂L[l̏ɕ\
			System.out.println(node.key + " " + node.data);			// node\
			printSubTreeR(node.left); 						// ؂L[l̏ɕ\
		}
	}

	//--- Sm[hL[l̍~ɕ\ ---//
	public void printReverse() {
		printSubTreeR(root);
	}

	// ŏ̃L[lm[hԂ
	private Node<K,V> getMinNode() {
		if (root == null)
			return null;
		else {
			Node<K,V> p = root;					// ɒ

			while (p.left != null)
				p = p.left;
			return p;
		}
	}

	// ő̃L[lm[hԂ
	private Node<K,V> getMaxNode() {
		if (root == null)
			return null;
		else {
			Node<K,V> p = root;					// ɒ

			while (p.right != null)
				p = p.right;
			return p;
		}
	}

	// ŏ̃L[lԂ
	public K getMinKey() {
		Node<K,V> minNode = getMinNode();
		return (minNode == null) ? null : minNode.getKey();
	}

	// ŏ̃L[lm[h̃f[^Ԃ
	public V getDataWithMinKey() {
		Node<K,V> minNode = getMinNode();
		return (minNode == null) ? null : minNode.getValue();
	}

	// ő̃L[lԂ
	public K getMaxKey() {
		Node<K,V> maxNode = getMaxNode();
		return (maxNode == null) ? null : maxNode.getKey();
	}

	// ő̃L[lm[h̃f[^Ԃ
	public V getDataWithMaxKey() {
		Node<K,V> maxNode = getMinNode();
		return (maxNode == null) ? null : maxNode.getValue();
	}
}
